#include "PB161-example.h"

#include <cstdint>
#include <iterator>
#include <memory>
/**
 * Tato demonstrace je rozsirenim domaci ulohy PB071/jaro2016/HW01.
 * Jejim ucelem je ilustrovat, jak na stejne uloze vypadaji ruzna
 * formatovani zdrojoveho kodu.
 * Nektere prvky C++, ktere pouziva nebudete znat az do konce semestru.
 */

void encoder::encode_stream(std::istream& in, std::ostream& out)
{
    auto flags = in.flags();
    in.unsetf(std::ios_base::skipws);

    std::ostream_iterator<uint8_t> out_it(std::cout);
    std::istream_iterator<unsigned char> end_of_stream;
    std::istream_iterator<unsigned char> in_it(std::cin);

    encode(in_it, end_of_stream, out_it);

    in.flags(flags);
}

int main(int argc, char** argv)
{
    std::unique_ptr<encoder> encoder_instance;
    if ((argc == 2) && std::string("--base64") == argv[1]) {
        std::unique_ptr<encoder> b64(new base64);
        encoder_instance.swap(b64);
    } else {
        std::unique_ptr<encoder> a85(new ascii85);
        encoder_instance.swap(a85);
    }

    // neni uplne univerzalni, cin neni otevren v binarnim rezimu
    encoder_instance->encode_stream(std::cin, std::cout);
    std::cout << std::endl;

    return 0;
}
